#!/bin/bash

CWD="@CMAKE_CURRENT_BINARY_DIR@"

TDIR=""
PID_STREAM=0
PID_LOCAL_DC=0

function kill_proc {
    if [ $1 -gt 0 ]; then
        echo "Closing process $1"
        kill $1
    fi
}

function cleanup {
    if [ "x$TDIR" != "x" ]; then
        if [ -d $TDIR ]; then
            rm -rf "$TDIR"
        fi
    fi
    kill_proc $PID_STREAM
    kill_proc $PID_LOCAL_DC
}

LOCAL_DC="$CWD/local_dc"
if [ ! -x "$LOCAL_DC" ]; then
    echo "local_dc is required"
    exit 1
fi

FE_STREAM_CHECK="$CWD/../fe_stream_test/fe_stream_check"
if [ ! -x "$FE_STREAM_CHECK" ]; then
  echo "fe_stream_check is required"
  exit 1
fi



if [ ! -r /dev/gpstime ]; then
  echo "the gpstime module must be loaded, configured, and accessible by this user"
  exit 1
fi

if [ ! -r /dev/mbuf ]; then
  echo "the mbuf module must be loaded, configured, and accessible by this user"
  exit 1
fi

PYTHON=""
which python > /dev/null
if [ $? -eq 0 ]; then
    PYTHON=`which python`
else
    which python3 > /dev/null
    if [ $? -eq 0 ]; then
        PYTHON=`which python3`
    else
        echo "Cannot find python or python3"
        exit 1
    fi
fi

trap cleanup EXIT

TDIR=`$PYTHON -c "from __future__ import print_function; import tempfile; print(tempfile.mkdtemp())"`
mkdir "$TDIR/ini_files"
mkdir "$TDIR/logs"

echo "Ini dir = $TDIR/ini_files"

"$FE_MULTI_STREAM_TEST" -S -i "$TDIR/ini_files" -M "$TDIR/ini_files/master" -k 300 -D 5,6,7,250,255,  > "$TDIR/logs/models" &
PID_STREAM=$!

echo "Streamer PID = $PID_STREAM"

sleep 1

echo `hostname` > "$TDIR/rtsystab" mod5 mod6 mod7 mod250 mod255

"$LOCAL_DC" -m 100 --systab "$TDIR/rtsystab" -d "$TDIR/ini_files" -b "local_dc" > "$TDIR/logs/local_dc" &
PID_LOCAL_DC=$!

echo "Local_dc PID = $PID_LOCAL_DC"

"$FE_STREAM_CHECK" -m local_dc -s 100 -v -c "$TDIR/ini_files/mod5.ini" "$TDIR/ini_files/tpchn_mod5.par" \
-c "$TDIR/ini_files/mod6.ini" "$TDIR/ini_files/tpchn_mod6.par" \
-c "$TDIR/ini_files/mod7.ini" "$TDIR/ini_files/tpchn_mod7.par" \
-c "$TDIR/ini_files/mod250.ini" "$TDIR/ini_files/tpchn_mod250.par" \
-c "$TDIR/ini_files/mod255.ini" "$TDIR/ini_files/tpchn_mod255.par"
RESULT=$?

exit $?
#echo "Press enter to continue..."
#DUMMY=""
#read DUMMY